<?php

namespace ZRay;

class Wordpress {

	public function beforeExit($context, &$storage) {
		$storage['generalInfo'][] = array('name'=>'WordPress Version','value'=>$GLOBALS['wp_version']);
		$storage['generalInfo'][] = array('name'=>'Debug Mode (WP_DEBUG)','value'=>WP_DEBUG ? 'On' : 'Off');
		$storage['generalInfo'][] = array('name'=>'Debug Log (WP_DEBUG_LOG)','value'=>WP_DEBUG_LOG ? 'On' : 'Off');
		$storage['generalInfo'][] = array('name'=>'Script Debug (SCRIPT_DEBUG)','value'=>SCRIPT_DEBUG ? 'On' : 'Off');
		$storage['generalInfo'][] = array('name'=>'Template','value'=>get_template());
		$storage['generalInfo'][] = array('name'=>'Template Directory','value'=>str_replace('\\','/',realpath(get_template_directory())));
		$storage['generalInfo'][] = array('name'=>'Doing Crons','value'=>get_transient( 'doing_cron' ) ? 'Yes' : 'No');
		if ( defined( 'SAVEQUERIES' ) && SAVEQUERIES ) {
			$storage['generalInfo'][] = array('name'=>'Save Queries (SAVEQUERIES)','value'=>SAVEQUERIES ? 'On' : 'Off');
		}
	}

}

if (class_exists('ZRayPlugin', false)) {

	$zre = new \ZRayPlugin('WordPress', true);

	$zre->setEnabledAfter('wp_initial_constants');

	$zre->traceFunction('wp_initial_constants', null, function () use ($zre) {

		$zrayWordpress = new Wordpress();

		// Cache
//		include 'WordpressCache.php';
//		$wordpressCache = new WordpressCache();
//		$zre->traceFunction('wp_cache_get', function () {
//		}, array($wordpressCache, 'wpCacheGetExit'));

			// Hooks
		include 'WordpressHooks.php';
		$wordpressHooks = new WordpressHooks($zre);
		$wordpressHooks->traceHooks();

		// Crons
		include 'WordpressCrons.php';
		$wordpressCrons = new WordpressCrons();

		// wp query
		include 'WordpressWpQuery.php';
		$wordpressWpQuery = new WordpressWpQuery();

		// plugins
		include 'WordpressPlugins.php';
		$wordpressPlugins = new WordpressPlugins();

		$zre->traceFunction(
			'wp_cache_close',
			null,
			function ($context, &$storage) use (
//				$wordpressCache,
				$wordpressHooks,
				$wordpressCrons,
				$wordpressWpQuery,
				$wordpressPlugins,
				$zrayWordpress
			) {
//				$wordpressCache->beforeExit($context, $storage);
				$wordpressHooks->beforeExit($context, $storage);
				$wordpressCrons->beforeExit($context, $storage);
				$wordpressWpQuery->beforeExit($context, $storage);
				$wordpressPlugins->beforeExit($context, $storage);
				$zrayWordpress->beforeExit($context, $storage);
			}
		);
	});
}